var updateButtonsState = function(event, ui) {
    if ($('.item-list li.ui-selected').length) {
        $('.header .delete-btn').removeAttr('disabled')
    } else {
        $('.header .delete-btn').attr('disabled', 'disabled');
    }
};

var freeSpace = -1;
var isOnline = true;
var defaultAlertQueue = [];

$(function(){

    $.ajaxSetup({ cache: false });

    $(document).bind('drop dragover', function (e) {
        if (!isOnline) {
            e.preventDefault();
            e.stopImmediatePropagation();
            return false;
        }
    });

    $(document).click(function(e) {
        if (!$(e.target).is('li.movie *') && !$(e.target).is('li.movie')) {
            $('.item-list li.movie').removeClass('ui-selected');
            updateButtonsState();
        }
    });

    var updateDimensions = function() {
        $('.header, .footer').css({
            'left':  -$(document).scrollLeft(),
            'width': $(document).width()
        });
    };

    $(window).resize(updateDimensions);
    $(document).bind('mousewheel DOMMouseScroll', function(e) {
        updateDimensions();
        var maxScrollTop = $('.wrapper').outerHeight() - $(window).height() + 140;
        if ($(document).scrollTop() > maxScrollTop) {
            $(document).scrollTop(maxScrollTop);
        }
    });

    $(document).bind('keydown', 'ctrl+a', function() {
        $('.item-list li.movie').addClass('ui-selected');
        updateButtonsState();
        return false;
    });

    $(document).bind('keydown', 'meta+a', function() {
        $('.item-list li.movie').addClass('ui-selected');
        updateButtonsState();
        return false;
    });

    $(document).bind('keydown', 'del', function() {
        if ($('.item-list li.ui-selected').length) {
            $('.header .delete-btn').click();
            return false;
        }
    });

    $('.item-list').bind("mousedown", function (e) {
        if ($(e.target).is('li.movie span')
            || $(e.target).is('li.movie img')
            || $(e.target).is('li.movie .movie-placeholder')
            || $(e.target).is('li.movie .folder-placeholder')) {

            if (e.shiftKey && $('.item-list li.ui-selected').length) {
                var li = $(e.target).parent('li');
                var liIndex = $('li.movie').index(li);
                var previousSelectedLi = null;
                var nextSelectedLi = null;
                for (var i = 0; i < $('.item-list li.ui-selected').length; i++) {
                    var currentLi = $('.item-list li.ui-selected')[i];
                    var currentIndex = $('li.movie').index($(currentLi));
                    if (previousSelectedLi == null && currentIndex < liIndex) {
                        previousSelectedLi = $(currentLi);
                    }
                    if (currentIndex > liIndex) {
                        if (previousSelectedLi == null) {
                            nextSelectedLi = $(currentLi);
                        }
                        break;
                    }
                }
                $('.item-list li.movie').removeClass('ui-selected');
                if (previousSelectedLi != null) {
                    for (var i = $('li.movie').index(previousSelectedLi); i <= liIndex; i++) {
                        $($('li.movie')[i]).addClass('ui-selected');
                    }
                } else {
                    for (var i = liIndex; i <= $('li.movie').index(nextSelectedLi); i++) {
                        $($('li.movie')[i]).addClass('ui-selected');
                    }
                }
                e.preventDefault();
                e.stopImmediatePropagation();
                return false;
            } else {
                e.metaKey = true;
            }
        } else {
            e.preventDefault();
            e.stopImmediatePropagation();
            return false;
        }
    }).selectable({
        filter: 'li.movie',
        selected: updateButtonsState,
        unselected: updateButtonsState
    });

    loadMovies();

    var refreshMoviesInterval = setInterval('loadMovies()', 10000);

    setInterval('updateDeviceInfo()', 60 * 1000);
    updateDeviceInfo();
    var jqXHR = null;
    $('#fileupload').fileupload({
        dataType: 'json',
        singleFileUploads: false,
        multipart: true,
        done: function(e, data) {
            if (!data.result.success) {
                alert('something going wrong');
                refreshMoviesInterval = setInterval('loadMovies()', 10000);
            } else {
                clearTimeout(this.refreshMoviesTimeout);
                clearInterval(refreshMoviesInterval);
				var allowedExtensions = ["mp4", "mkv", "mk3d", "m4v",
					"avi", "divx", "mov" , "wmv",
					"rm" , "ogv" , "flv",
					"3gp", "bik" , "mpg",
					"ogm", "mpeg", "ts", "tp",
					"m2v", "m2t", "m2ts",
					"mts", "dvr-ms", "wtv",
					"asf", "webm", "srt", "ssa",
					"ass", "sub", "txt", "iso",
					"rmvb", "vob", "mxf"];
                for (var i = 0; i < data.files.length; i++) {
                    var file = data.files[i].name;
                    if (data.files[i].hasOwnProperty('relativePath')) {
						if (data.files[i].relativePath.length > 0) {
							continue;
						}
					}
                    var title = file.substr(0, file.lastIndexOf('.'));
                    var extension = file.substr(file.lastIndexOf('.') + 1);
                    if ($('.item-list li.movie[url="/'+file+'"]').length == 0
							&& file.indexOf('.') !== 0
							&& $.inArray(extension, allowedExtensions) > -1) {
                        $('#newMovieTmpl').tmpl([{name: title, url: '/' + file}]).insertBefore('.item-list li.add-new');
                    }
                }
                for (var i = 0; i < data.folders.length; i++) {
					var folder = data.folders[i].split("/")[0];
					if ($('.item-list li.folder[title="'+folder+'"]').length == 0) {
                        $('#newFolderTmpl').tmpl([{name: folder}]).insertAfter('.item-list li.folder:last');
                    }
				}
                setTimeout(function() {
                    refreshMoviesInterval = setInterval('loadMovies()', 10000);
                }, 5000);
            }
            $('.uploading').animate({
                opacity: 0
            }, 500, function() { $(this).hide(); });
        },
        add: function(e, data) {
            if (!isOnline) {
                return;
            }
            var allowedExtensions = ["mp4", "mkv", "mk3d", "m4v", 
                "avi", "divx", "mov" , "wmv",
                "rm" , "ogv" , "flv",
                "3gp", "bik" , "mpg",
                "ogm", "mpeg", "ts", "tp",
                "m2v", "m2t", "m2ts",
                "mts", "dvr-ms", "wtv",
                "asf", "webm", "srt", "ssa",
                "ass", "sub", "jpeg",
                "jpg", "jpe", "png",
                "bmp", "gif", "tiff",
                "tif", "txt", "iso",
                "rmvb", "vob", "mxf"];
            var uploadSize = 0;
            var allFilesAllowed = true;
            var duplicates = [];
            for (var i = 0; i < data.files.length; i++) {
				var file = data.files[i].name;
                var extension = file.substr((file.lastIndexOf('.') +1)).toLowerCase();
                uploadSize += data.files[i].size;
                if (allowedExtensions.indexOf(extension) < 0 && file.indexOf('.') !== 0) {
                    allFilesAllowed = false;
                    break;
                }
                $('.item-list li.movie[url]').each(function() {
                    var url = $(this).attr('url');
                    var filename = decodeURIComponent(url.substr(url.lastIndexOf('/') + 1));
                    if (filename == file) {
                        duplicates.push(filename);
                    }
                });
            }
            if (allFilesAllowed) {
                var ignoreDuplicates = true;
                if (duplicates.length > 0) {
                    
                    ignoreDuplicates = confirm('File' + (duplicates.length > 1 ? 's' : '') + ' "'
                        + duplicates.join('", "') + '" already exist' + (duplicates.length > 1 ? '' : 's')
                        + '. Do you want to replace ' + (duplicates.length > 1 ? 'them' : 'it') + '?');
                }
                if (ignoreDuplicates) {
                    if (freeSpace < 0 || uploadSize <= freeSpace) {
                        $('.uploading').css({ opacity: 0 });
                        $('.uploading .window.upload p').text('Uploading ' + data.files.length + ' file' + (data.files.length > 1 ? 's' : ''));
                        $('.uploading .window.upload .current-progress').width(0);
                        $('.uploading .window.upload .progress-byte').text('0 / ' + parseSize(uploadSize));
                        $('.uploading .window.upload .progress-percent').text('0%');
                        $('.uploading').show();
                        $('.uploading').animate({
                            opacity: 1
                        }, 500, function() {
                            clearInterval(refreshMoviesInterval);
                            data.formData = { movies: [] };
                            data.folders = [];
                            for (var i in data.files) {
								var prefix = $('.item-list').attr('path');
								if (prefix.length) {
									prefix += '/';
								}
								if (data.files[i].hasOwnProperty('relativePath')) {
									prefix += data.files[i].relativePath;
									if (data.files[i].relativePath.length > 0
											&& data.folders.indexOf(data.files[i].relativePath) < 0) {
										data.folders.push(data.files[i].relativePath);
									}
								}
								data.formData.movies.push(prefix + data.files[i].name);
							}
							data.formData.movies = data.formData.movies.join(':');
                            jqXHR = data.submit();
                        });
                    } else {
                        alert('There is not enough space available');
                    }
                }
            } else {
                alert('Filetype not allowed');
            }
        },
        progressall: function(e, data) {
            var progress = parseInt(data.loaded / data.total * 100, 10);
            $('.uploading .window.upload .current-progress').width(progress + '%');
            $('.uploading .window.upload .progress-percent').text(progress + '%');
            var tier = getSizeTier(data.total);
            $('.uploading .window.upload .progress-byte').text(parseSize(data.loaded, tier, true) + ' / ' + parseSize(data.total, tier));
            if (data.loaded != data.total && this.finished) {
                this.finished = false;
                $('.uploading').stop();
                $('.uploading').show();
                $('.uploading').css({ opacity: 1 });
            }
            if (data.loaded == data.total) {
                this.finished = true;
                $('.uploading').animate({
                    opacity: 0
                }, 500, function() { $(this).hide(); });
                this.refreshMoviesTimeout = setTimeout(function() {
                    loadMovies();
                    refreshMoviesInterval = setInterval('loadMovies()', 10000);
                }, 2000);
            }
        }
    }).error(function (jqXHR, textStatus, errorThrown) {
        if (errorThrown === 'abort') {
            alert('File Upload has been canceled');
            $('.uploading').animate({
                opacity: 0
            }, 500, function() { $(this).hide(); });
        }
    });
    
    var uploadAbortedByUser = false;
    
    $('#fileupload').bind('fileuploadfail', function (e, data) {
        if (uploadAbortedByUser) {
            uploadAbortedByUser = false;
        } else {
            $('.uploading').animate({
                opacity: 0
            }, 500, function() { $(this).hide(); });
            loadMovies();
            refreshMoviesInterval = setInterval('loadMovies()', 10000);
        }
    });

    $('.add-new img, .add-btn').click(function() {
        $('#fileupload').click();
    });

    $('.header .delete-btn').click(function() {
        if (confirm('Are you sure you want to delete the selected movie(s)?')) {
            var selectedMovies = [];
            $('.item-list li.ui-selected[movie-id]').each(function() { selectedMovies.push($(this).attr('movie-id')); });
            $('.item-list li.ui-selected[folder-id]').each(function() { selectedMovies.push($(this).attr('folder-id')); });
            $.post('data/delete.json', JSON.stringify(selectedMovies), function(data) {
                if (data.success) {
                    alert('movies successfully removed');
                    $('.item-list li.ui-selected').remove();
                    loadMovies();
                    updateDeviceInfo();
                } else {
                    alert('something going wrong');
                }
            }, 'json').fail(function(jqXHR, textStatus, errorThrown) {
                alert('error: ' + errorThrown);
            });
        }
    });
    
    $('.window.load .current-progress').animate({
        width: '100%'
    }, 2000, function() {
        $('.wrapper').show();
        $('.loading').hide();
    });

    $('.window.upload .cancel').click(function() {
        if (jqXHR) {
            uploadAbortedByUser = true;
            jqXHR.abort();
            $('.uploading').animate({
                opacity: 0
            }, 500, function() { $(this).hide(); });
        }
        refreshMoviesInterval = setInterval('loadMovies()', 10000);
    });
    
    $('.back-btn').click(function() {
		changePath('/', '');
	});
});

function loadMovies() {
	currentFolder = $('.item-list').attr('folder-id');
    if ($('.ui-selecting').length) {
        return;
    }
    $.getJSON('data/movies.json', function(data) {
		var selectedMovies = [];
		var selectedFolders = [];
		$('.item-list li.ui-selected[movie-id]').each(function() { 
			selectedMovies.push($(this).attr('movie-id'));
		});
		$('.item-list li.ui-selected[folder-id]').each(function() { 
			selectedFolders.push($(this).attr('folder-id'));
		});
		$('.item-list li.movie').remove();
		if (currentFolder == "/") {
			$('#movieTmpl').tmpl(data.movies).prependTo('.item-list');
			$('#folderTmpl').tmpl(data.folders).prependTo('.item-list');
		} else {
			for (var i = 0; i < data.folders.length; i++) {
				if (data.folders[i].id == currentFolder) {
					$('#movieTmpl').tmpl(data.folders[i].movies).prependTo('.item-list');
					break;
				}
			}
		}
		for (var i = 0; i < selectedMovies.length; i++) {
			$('.item-list li[movie-id='+selectedMovies[i]+']').addClass('ui-selected');
		}
		for (var i = 0; i < selectedFolders.length; i++) {
			$('.item-list li[folder-id='+selectedFolders[i]+']').addClass('ui-selected');
		}
		$('.movie.folder').dblclick(function() {
			changePath($(this).attr('folder-id'), $(this).attr('title'));
		});
        updateButtonsState();
        updateOnlineState(true);
    }).fail(function(jqXHR, textStatus, errorThrown) {
        updateButtonsState();
        updateOnlineState(false);
    });
}

function setAlertVisible(alertWindow, visible){
    if (!visible) {
        if ($(alertWindow).is(':visible')) {
            $(alertWindow).animate({
                opacity: 0
            }, 500, function() { $(this).hide(); });
        }
    } else {
        if (!$(alertWindow).is(':visible')) {
            $(alertWindow).css({ opacity: 0 });
            $(alertWindow).show();
            $(alertWindow).animate({
               opacity: 1
            }, 500);
        }
    }
}

function pushAlertToQueue(alertWindow, queue){
    if ($.inArray(alertWindow, queue) >= 0)
        return;
    
    if (queue.length == 0)
        setAlertVisible(alertWindow, true);
    
    queue.push(alertWindow);
}

function popAlertFromQueue(alertWindow, queue){
    var alertIndex = $.inArray(alertWindow, queue);
    if (alertIndex >= 0){
        queue.splice(alertIndex, 1);
        setAlertVisible(alertWindow, false);
    }

    if (queue.length > 0){
        var newVisibleAlert = queue[0];
        setAlertVisible(newVisibleAlert, true);
    }
}

function setAlertVisibleInQueue(alertWindow, visible){
    if (visible)
        pushAlertToQueue(alertWindow, defaultAlertQueue);
    else
        popAlertFromQueue(alertWindow, defaultAlertQueue);
}

function updateOnlineState(online) {
    isOnline = online;
    setAlertVisibleInQueue('.connection-alert', !online);
}

function showBrowserNotSupported(){
    setAlertVisibleInQueue('.not-supported-alert', true);
}

function updateDeviceInfo() {
    $.getJSON('data/device-info.json', function(data) {
        freeSpace = data.free_space;
        $('.footer .device-info .device-name').html(data.device_name);
        $('.footer .device-info .free-space').html(parseSize(data.free_space) + ' Available');
        $('.footer .device-info .used-space').width((data.total_space - data.free_space) * 100/data.total_space + '%');
        $('.footer .device-info').show();
    }).fail(function(jqXHR, textStatus, errorThrown) {
        updateOnlineState(false);
    });
}

function getSizeTier(size) {
	var tier = 0;
	while (size >= 1024) {
		size = size / 1024;
		tier++;
	}
	return tier;
}

function parseSize(size, tier, withoutSuffix) {
	var suffix = ["bytes", "KB", "MB", "GB", "TB", "PB"];
	if (typeof tier === 'undefined') {
		tier = 0;

		while(size >= 1024) {
			size = size / 1024;
			tier++;
		}
	} else {
		for (var i = 0; i < tier; i++) {
			size = size / 1024;
		}
	}

	return Math.round(size * 100) / 100 + ((typeof withoutSuffix === 'undefined' || !withoutSuffix) ? " " + suffix[tier] : '');
}

function adjustListSize() {
    $('.item-list li.empty').remove();
    var rowCount = 0;
    var columnCount = 0;
    var prevTopPosition = 0;
    $('.item-list li').each(function() {
        if ($(this).position().top != prevTopPosition) {
            if (prevTopPosition != 0 && !columnCount) {
                columnCount = $('.item-list li').index($(this));
            }
            prevTopPosition = $(this).position().top;
            rowCount++;
        }
    });
    while($('.item-list li').length < (rowCount * columnCount)) {
        $('<li class="empty"></li>').appendTo('.item-list');
    }
}

function changePath(folderId, folderName) {
	$('.item-list').attr('folder-id', folderId);
	$('.item-list').attr('path', folderName);
	if (folderId == '/') {
		$('.back-btn').hide();
		$('.header .bg.center .logo').show(0);
		$('.header .bg.center .folder-name').hide(0);
	} else {
		$('.back-btn').show();
		$('.header .bg.center .logo').hide(0);
		$('.header .bg.center .folder-name').text(folderName);
		$('.header .bg.center .folder-name').show(0);
	}
	loadMovies();
}


